;###############################################################################
;## mIRC HTTP Library v0.1
;####
;#
;#    Author: Meij <meijie@gmail.com>
;#
;#    Credits:
;#      ^Vampire^: for _mhttplib_urlencode / _mhttplib_urldecode
;#                 URL: http://www.mircscripts.org/comments.php?cid=3256
;#
;###############################################################################

;####
;## Public Functions
;###############################################################################

alias _mhttplib_new {
  var %id = $_mhttplib_generate_id
  _mhttplib_generate_defaults %id
  return %id
}

alias _mhttplib_set {
  var %2 = $+($2,*)

  var %sc = $1
  if ($regex($1, ^(_mhttplib_.[^_]+))) { var %sc = $regml(1) }

  if (%2 iswm url) {
    if (!$_mhttplib_check_url($3).text) {
      _mhttplib_hadd %sc error Invalid URL
      return $false
    }

    _mhttplib_hadd $+(%sc,_cheaders) Host $regml(2)
  }
  elseif (%2 iswm port) {
    if ($3 !isnum) {
      _mhttplib_hadd %sc error Invalid port number
      return $false
    }
  }
  elseif (%2 iswm method) {
    if ( ($3 != GET) && ($3 != POST) && ($3 != HEAD) ) {
      _mhttplib_hadd %sc error Invalid HTTP method
      return $false
    }
  }
  elseif (%2 iswm header) {
    _mhttplib_hadd $+(%sc,_cheaders) $3 $4-
    return $true
  }
  elseif (%2 iswm version) {
    if ( ($3- != HTTP/1.0) && ($3- != HTTP/1.1) ) {
      _mhttplib_hadd %sc error Invalid HTTP version
      return $false
    }
  }
  elseif (%2 iswm authentication) {
    _mhttplib_hadd $+(%sc,_cheaders) Authorization Basic $encode($+($3,:,$$4))
    return $true
  }
  elseif (%2 iswm cookie) {
    var %sk = $+(%sc,_cookies)

    _mhttplib_hadd %sk $3 $$4
    return $true
  }
  elseif (%2 iswm post) {
    var %3 = $$3

    if ($3 == -b) { var %b = $true, %3 = $$4 }
    _mhttplib_hadd $iif(%b,-b) $1 $2 %3

    return $true
  }
  elseif ( (%2 !iswm callback) && (%2 !iswm debug) ) {
    _mhttplib_hadd %sc error Illigal set option ' $+ $2 $+ '
    return $false
  }

  _mhttplib_hadd $1 $2 $$3

  return $true
}

alias _mhttplib_run {
  if (!$hget($1)) {
    _mhttplib_hadd $1 error Connection id doesnt exist
    return $false
  }
  if ($sock($1)) {
    _mhttplib_hadd $1 error Connection already open
    return $false
  }
  if (!$_mhttplib_check_config($1)) {
    ; errors set in _mhttplib_check_config
    return $false
  }

  var %sh = $+($1,_headers), %sd = $+($1,_data), %sk = $+(%sc,_cookies)
  if ($hget(%sh)) { hfree %sh }
  if ($hget(%sd)) { hfree %sd }

  ; Convert cookies -> Cookie: header, append to any that exist already
  .echo -q $hget(%sh, Cookie, &cookies)
  var %t = $hget(%sk, 0).item, %i = 1
  while (%i <= %t) {
    var %k = $hget(%sk, %i).item
    bset -t &cookies $calc($bvar(&cookies, 0) + 1) $iif($bvar(&cookies, 0) > 0,;) %k $+ = $+ $hget(%sk, %k)

    inc %i
  }

  if ($bvar(&cookies, 0) > 0) {
    _mhttplib_hadd -b %sh Cookie &cookies
  }

  _mhttplib_check_url $1

  sockopen $1 $regml(2) $hget($1, port)

  return $true
}

alias _mhttplib_cleanup {
  if (!$hget($1)) {
    _mhttplib_hadd $1 error Connection id doesnt exist
    return $false
  }

  if ($sock($1)) { sockclose $1 }
  hfree - [ $+ [ $iif($hget($1, debug),s) ] $+ ] w $+($1,*)

  return $true
}

alias _mhttplib_urlencode {
  return $regsubex($1-,/\G(.)/g,$iif(\t !isalnum && !$prop,$chr(37) $+ $base($asc(\t),10,16),\t))
}

alias _mhttplib_urldecode {
  return $replacex($regsubex($1,/%(\w\w)/g,$chr($iif($base(\t,16,10) != 32,$v1,255))),$chr(255),$chr(32))
}

alias _mhttplib_mimetype {
  var %m = plain/text
  if (*.jpg iswm $1-) { var %m = image/pjpeg }
  elseif (*.gif iswm $1-) { var %m = image/gif }
  elseif (*.png iswm $1-) { var %m = image/png }

  return %m
}

alias _mhttplib_multipart {
  var %file = $false, %binary = $false

  if (-* iswm $1) {
    if (*f* iswm $1) { var %file = $true }
    if (*b* iswm $1) { var %binary = $true }

    tokenize 32 $2-
  }

  var %id = $+(--,$1), %sc = $1
  if ($hget(%sc, post)) {
    .echo -q $hget(%sc, post, &multipart)
  }

  bset -t &multipart $calc($bvar(&multipart, 0) + 1) %id $+ $iif(!$2,--) $+ $crlf

  if ($2) {
    bset -t &multipart $calc($bvar(&multipart, 0) + 1) Content-Disposition: form-data; name=" $+ $2 $+ "
    if (%file) {
      bset -t &multipart $calc($bvar(&multipart, 0) + 1) ; filename=" $+ $3- $+ "
      bset -t &multipart $calc($bvar(&multipart, 0) + 1) $crlf $+ Content-Type: $_mhttplib_mimetype($3-)
    }
    bset -t &multipart $calc($bvar(&multipart, 0) + 1) $str($crlf, 2)
  }

  if ($3) {
    if (%file = $true) {
      bread $+(",$3-,") 0 $file($3-).size &file_data
      bcopy &multipart $calc($bvar(&multipart, 0) + 1) &file_data 1 -1
    }
    elseif (%binary == $true) { bcopy &multipart $calc($bvar(&multipart, 0) + 1) $3 1 -1 }
    else { bset -t &multipart $calc($bvar(&multipart, 0) + 1) $3- }
  }

  if ($2) {
    bset -t &multipart $calc($bvar(&multipart, 0) + 1) $crlf
  }

  _mhttplib_hadd -b %sc post &multipart

  return $true
}

alias _mhttplib_unchunk {
  var %ps = 1, %sd = $+($1,_data)

  .echo -q $hget(%sd, data, &data)

  if ($bvar(&data, 0) == 0) {
    _mhttplib_hadd $1 error No data to unchunk
    return $false
  }

  while (%ps) {
    var %length = $null

    if (!$regex($bvar(&data, %ps, 800).text, ^([a-zA-Z0-9]+)(?:;.*?|)\r\n)) {
      _mhttplib_hadd $1 error Unable to correctly parse chunked data
      return $false
    }

    var %length = $base($regml(1), 16, 10)
    if (%length === 0) {
      break
    }

    var %ps = $calc($bfind(&data, %ps, 13 10) + 2)

    bcopy &chunked $calc($bvar(&chunked, 0) + 1) &data %ps %length

    var %length = $calc(%length + 2); + \r\n
    var %ps = $calc(%ps + %length)
  }

  if ($bvar(&chunked, 0) == 0) {
    _mhttplib_hadd $1 error No chunked data found
    return $false
  }

  _mhttplib_hadd -b %sd data &chunked
}

;####
;## Socket Events
;###############################################################################

on *:SOCKOPEN:_mhttplib_*: {
  var %sh = $+($sockname,_cheaders), %sc = $sockname

  if ($hget(%sc, method) == POST) {
    .echo -q $hget(%sc, post, &sock_data)

    if (!$hget(%sh, Content-Type)) {
      _mhttplib_hadd %sh Content-Type application/x-www-form-urlencoded
    }
    _mhttplib_hadd %sh Content-Length $bvar(&sock_data, 0)
  }

  _mhttplib_check_url %sc
  _mhttplib_sockwrite $sockname $upper($hget(%sc, method)) $regml(3) $upper($hget(%sc, version)) $+ $crlf

  var %t = $hget(%sh, 0).item, %i = 1
  while (%i <= %t) {
    var %h = $hget(%sh, %i).item
    _mhttplib_sockwrite $sockname $+(%h,:) $hget(%sh, %h) $+ $crlf
    inc %i
  }

  _mhttplib_sockwrite $sockname $crlf

  if ($hget(%sc, method) == POST) {
    if ($bvar(&sock_data, 0) > 0) {
      sockwrite $sockname &sock_data
    }
  }
}

on *:SOCKREAD:_mhttplib_*: {
  if ($sockerr > 0) { return }

  :nextread
  sockread &data

  if ($sockbr == 0) { return }

  var %sr = $+($sockname,_raw)
  _mhttplib_hadd -b %sr $_mhttplib_hincr(%sr) &data

  goto nextread
}

on *:SOCKCLOSE:_mhttplib_*: {
  _mhttplib_post_processing $sockname
  return
}

;####
;## Private Functions
;###############################################################################

alias -l _mhttplib_hadd {
  if ($1 == -b) { if ($bvar($$4, 0) > 0) { hadd -mbu300 $2 $3 $4 } }
  else { hadd -mu300 $1 $2 $$3- }
}

alias -l _mhttplib_hincr {
  var %i 1
  while ($hget($1, %i).item) {
    inc %i
  }
  return %i
}

alias -l _mhttplib_sockwrite {
  if ($hget($1, debug)) {
    echo -st (Debug) sock: $1 data: $2-
  }

  sockwrite -t $1 $$2-
}

alias -l _mhttplib_generate_id {
  :start
  var %s = $+(_mhttplib_,$md5($ticks))
  if ( ($sock(%s)) || ($hget(%s)) ) { goto start }

  return %s
}

alias -l _mhttplib_generate_defaults {
  _mhttplib_hadd $1 port 80
  _mhttplib_hadd $1 method GET
  _mhttplib_hadd $1 version HTTP/1.0

  _mhttplib_hadd $+($1,_cheaders) Accept-Language en-us
  _mhttplib_hadd $+($1,_cheaders) User-Agent mIRCHTTPLib/0.1
  _mhttplib_hadd $+($1,_cheaders) Connection close
}

alias -l _mhttplib_check_url {
  var %url = $iif($prop == text, $1, $hget($1, url))

  if ($regex(%url, ^([^:]*)://([^/]+)?(.*)$)) {
    return $true
  }

  return $false
}

alias -l _mhttplib_check_config {
  var %sc = $1

  if (!$hget(%sc, url)) {
    _mhttplib_hadd $1 error Error: 'url' config setting not set
    return $false
  }

  return $true
}

alias -l _mhttplib_post_processing {
  var %i 1, %h = $false, %sr = $+($1,_raw), %sd = $+($1,_data), %sh = $+($1,_headers), %sc = $1

  while ($hget(%sr, %i).item) {
    .echo -q $hget(%sr, %i, &raw_data)
    inc %i

    if ($bvar(&raw_data, 0) == 0) { continue }

    if ($bvar(&data, 0) == 0) {
      if ($bvar(&raw_data, 1, 7).text == HTTP/1.) {
        var %h = $true
      }
    }

    if (%h) {
      var %l = $calc($bfind(&raw_data, 1, 13 10 13 10) + 2)

      bcopy &headers $calc($bvar(&headers, 0) + 1) &raw_data 1 $iif(%l > 9, %l, -1)

      if (%l > 0) {
        var %h = $false

        if ($calc(%l + 2) > $bvar(&raw_data, 0)) {
          continue
        }

        bcopy -c &raw_data 1 &raw_data $calc(%l + 2) -1
      }
    }

    if (!%h) {
      bcopy &data $calc($bvar(&data, 0) + 1) &raw_data 1 -1
    }

    bunset &raw_data
  }

  if ($hget(%sr)) { hfree %sr }

  var %pe = $bfind(&headers, 1, 13 10), %pl 1
  while (%pe) {
    bcopy &tmp 1 &headers %pl $calc(%pe - %pl)

    if (!%status) {
      var %status = $bvar(&tmp, 1, $bvar(&tmp, 0)).text
    }
    else {
      var %tp = $bfind(&tmp, 1, 58), %ph = $bvar(&tmp, 1, $calc(%tp - 1)).text, %pd = $bvar(&tmp, $calc(%tp + 1), $bvar(&tmp, 0)).text
      _mhttplib_hadd %sh %ph %pd
    }

    var %pl = $calc(%pe + 2), %pe = $bfind(&headers, %pl, 13 10)
    bunset &tmp
  }

  _mhttplib_hadd -b %sd data &data

  .timer -m 1 1 $hget(%sc, callback) $1 %status
}
